## mingw-w64-aws-sdk-cpp-1.11.479-1.src.tar.zst

=== CMakeLists.txt ===
# Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
# SPDX-License-Identifier: Apache-2.0.
#

cmake_minimum_required(VERSION 3.13 FATAL_ERROR)

option(LEGACY_BUILD "If enabled, the SDK will use 1.11.0 version of CMake files to build" ON)
if (LEGACY_BUILD)
    message(WARNING "In 1.11 releases, we are releasing experimental alternative building mode."
            "By setting -DLEGACY_BUILD=OFF you can test our advances in modern CMake building and "
            "provide early feedback. "
            "The legacy support is set by default in 1.11, when you complete build updating scripts please "
            "update the build flags as mentioned in README.md and set -DLEGACY_BUILD=OFF. "
            "The legacy support will be removed at 1.12.0 release.")

    if (POLICY CMP0077)
        cmake_policy(SET CMP0077 OLD) # CMP0077: option() honors normal variables. Introduced in 3.13
    endif ()

    get_filename_component(AWS_NATIVE_SDK_ROOT "${CMAKE_CURRENT_SOURCE_DIR}" ABSOLUTE)

    # Cmake invocation variables:
    #   BUILD_ONLY - only build project identified by this variable, a semi-colon delimited list, if this is set we will build only the projects listed. Core will always be built as will its unit tests.
    #                    Also if a high level client is specified then we will build its dependencies as well. If a project has tests, the tests will be built.
    #   ADD_CUSTOM_CLIENTS - semi-colon delimited list of format serviceName=<yourServiceName>,version=<theVersionNumber>;serviceName2=<yourOtherServiceName>,version=<versionNumber2>
    #                          to use these arguments, you should add the api definition .normal.json file for your service to the api-description folder in the generator.
    #   NDK_DIR - directory where the android NDK is installed; if not set, the location will be read from the ANDROID_NDK environment variable
    #   CUSTOM_PLATFORM_DIR - directory where custom platform scripts, modules, and source resides
    #   AWS_SDK_ADDITIONAL_LIBRARIES - names of additional libraries to link into aws-cpp-sdk-core in order to support unusual/unanticipated linking setups (static curl against static-something-other-than-openssl for example)

    option(ENABLE_UNITY_BUILD "If enabled, the SDK will be built using a single unified .cpp file for each service library.  Reduces the size of static library binaries on Windows and Linux" ON)
    option(MINIMIZE_SIZE "If enabled, the SDK will be built via a unity aggregation process that results in smaller static libraries; additionally, release binaries will favor size optimizations over speed" OFF)
    option(BUILD_SHARED_LIBS "If enabled, all aws sdk libraries will be build as shared objects; otherwise all Aws libraries will be built as static objects" ON)
    option(FORCE_SHARED_CRT "If enabled, will unconditionally link the standard libraries in dynamically, otherwise the standard library will be linked in based on the BUILD_SHARED_LIBS setting" ON)
    option(SIMPLE_INSTALL "If enabled, removes all the additional indirection (platform/cpu/config) in the bin and lib directories on the install step" ON)
    option(USE_CRT_HTTP_CLIENT "If enabled, the common runtime HTTP client will be used, and the legacy systems such as WinHttp and libcurl will not be built or included" OFF)
    option(NO_HTTP_CLIENT "If enabled, no platform-default http client will be included in the library.  For the library to be used you will need to provide your own platform-specific implementation" OFF)
    option(NO_ENCRYPTION "If enabled, no platform-default encryption will be included in the library.  For the library to be used you will need to provide your own platform-specific implementations" OFF)
    option(USE_IXML_HTTP_REQUEST_2 "If enabled on windows, the com object IXmlHttpRequest2 will be used for the http stack" OFF)
    option(ENABLE_RTTI "Flag to enable/disable rtti within the library" ON)
    option(ENABLE_TESTING "Flag to enable/disable building unit and integration tests" ON)
    option(AUTORUN_UNIT_TESTS "Flag to enable/disable automatically run unit tests after building" ON)
    option(ANDROID_BUILD_CURL "When building for Android, should curl be built as well" ON)
    option(ANDROID_BUILD_OPENSSL "When building for Android, should Openssl be built as well" ON)
    option(ANDROID_BUILD_ZLIB "When building for Android, should Zlib be built as well" ON)
    option(FORCE_CURL "Forces usage of the Curl client rather than the default OS-specific api" OFF)
    option(ENABLE_ADDRESS_SANITIZER "Flags to enable/disable Address Sanitizer for gcc or clang" OFF)
    option(BYPASS_DEFAULT_PROXY "Bypass the machine's default proxy settings when using IXmlHttpRequest2" ON)
    option(BUILD_DEPS "Build third-party dependencies" ON)
    option(USE_OPENSSL "Set this if you want to use your system's OpenSSL 1.0.2/1.1.1 compatible libcrypto" ON)
    option(ENABLE_CURL_LOGGING "If enabled, Curl's internal log will be piped to SDK's logger" ON)
    option(ENABLE_HTTP_CLIENT_TESTING "If enabled, corresponding http client test suites will be built and run" OFF)
    option(CUSTOM_MEMORY_MANAGEMENT "If set to ON, generates the sdk project files with custom memory management enabled, otherwise disables it" OFF)
    option(REGENERATE_CLIENTS "If set to ON, all clients being built on this run will be regenerated from the api definitions, this option involves some setup of python, java 8+, and maven" OFF)
    option(ENABLE_VIRTUAL_OPERATIONS "This option usually works with REGENERATE_CLIENTS. \
                                If enabled when doing code generation, operation related functions in service clients will be marked as virtual. \
                                If disabled when doing code generation, virtual will not be added to operation functions and service client class will be marked as final. \
                                If disabled, SDK will add compiler flags '-ffunction-sections -fdata-sections' for gcc and clang when compiling. \
                                You can utilize this feature to work with your linker to reduce binary size of your application on Unix platforms when doing static linking in Release mode." ON)
    option(REGENERATE_DEFAULTS "If set to ON, defaults mode configuration will be regenerated from the JSON definitions, this option involves some setup of python, java 8+, and maven" OFF)
    option(ENABLE_ZLIB_REQUEST_COMPRESSION "For services that support it, request content will be compressed. On by default if dependency available" ON)
    option(DISABLE_INTERNAL_IMDSV1_CALLS "Disables IMDSv1 internal client calls" OFF)
    option(BUILD_BENCHMARKS "Enables building the benchmark executable" OFF)
    option(BUILD_OPTEL "Enables building the open telemetry implementation of tracing" OFF)
    option(AWS_SDK_WARNINGS_ARE_ERRORS "Compiler warning is treated as an error. Try turning this off when observing errors on a new or uncommon compiler" ON)
    option(BUILD_OPTEL_OTLP_BENCHMARKS "Enables building the benchmark tests with open telemetry OTLP clients" OFF)
    option(USE_TLS_V1_2 "Set http client to enforce TLS 1.2" ON)
    option(USE_TLS_V1_3 "Set http client to enforce TLS 1.3" OFF)
    option(ENABLE_SMOKE_TESTS "Enable smoke tests" OFF)
    option(DISABLE_DNS_REQUIRED_TESTS "Disable unit tests that require DNS lookup to succeed, useful when using a http client that does not perform DNS lookup" OFF)


    set(AWS_USER_AGENT_CUSTOMIZATION "" CACHE STRING "User agent extension")
    set(AWS_TEST_REGION "US_EAST_1" CACHE STRING "Region to target integration tests against")
    set(AWS_AUTORUN_LD_LIBRARY_PATH CACHE STRING "Path to append into LD_LIBRARY_PATH for unit tests autorun by cmake. Set this if custom runtime libs are required for overridden dependencies.")
    set(BUILD_ONLY "" CACHE STRING "A semi-colon delimited list of the projects to build")
    set(CPP_STANDARD "11" CACHE STRING "Flag to upgrade the C++ standard used. The default is 11. The minimum is 11.")

    get_property(is_multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
    if (NOT ${is_multi_config})
        set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Release build by default.")
    endif ()
    if (DISABLE_INTERNAL_IMDSV1_CALLS)
        add_definitions(-DDISABLE_IMDSV1)
    endif ()
    if (USE_TLS_V1_2)
        add_definitions(-DENFORCE_TLS_V1_2)
    endif ()
    if (USE_TLS_V1_3)
        add_definitions(-DENFORCE_TLS_V1_3)
    endif ()

    if (DISABLE_DNS_REQUIRED_TESTS)
        add_definitions(-DDISABLE_DNS_REQUIRED_TESTS)
    endif ()

    #From https://stackoverflow.com/questions/18968979/how-to-get-colorized-output-with-cmake
    if (NOT WIN32)
        string(ASCII 27 Esc)
        set(ColourReset "${Esc}[m")
        set(ColourBold "${Esc}[1m")
        set(Red "${Esc}[31m")
        set(Green "${Esc}[32m")
        set(Yellow "${Esc}[33m")
        set(Blue "${Esc}[34m")
        set(Magenta "${Esc}[35m")
        set(Cyan "${Esc}[36m")
        set(White "${Esc}[37m")
        set(BoldRed "${Esc}[1;31m")
        set(BoldGreen "${Esc}[1;32m")
        set(BoldYellow "${Esc}[1;33m")
        set(BoldBlue "${Esc}[1;34m")
        set(BoldMagenta "${Esc}[1;35m")
        set(BoldCyan "${Esc}[1;36m")
        set(BoldWhite "${Esc}[1;37m")
    endif ()

    # backwards compatibility with old command line params
    if ("${STATIC_LINKING}" STREQUAL "1")
        set(BUILD_SHARED_LIBS OFF)
    endif ()

    if (MINIMIZE_SIZE)
        message(STATUS "MINIMIZE_SIZE enabled")
        set(ENABLE_UNITY_BUILD ON) # MINIMIZE_SIZE always implies UNITY_BUILD
    endif ()

    set(PYTHON_CMD "python")

    # CMAKE_MODULE_PATH is a CMAKE variable. It contains a list of paths
    # which could be used to search CMAKE modules by "include()" or "find_package()", but the default value is empty.
    # Add ${CMAKE_INSTALL_LIBDIR}/cmake and ${CMAKE_PREFIX_PATH}/lib/cmake to search list
    list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")
    set(AWS_MODULE_DIR "/${CMAKE_INSTALL_LIBDIR}/cmake")
    string(REPLACE ";" "${AWS_MODULE_DIR};" AWS_MODULE_PATH "${CMAKE_PREFIX_PATH}${AWS_MODULE_DIR}")
    list(APPEND CMAKE_MODULE_PATH ${AWS_MODULE_PATH})

    # include() will "load and run" cmake script
    include(resolve_platform)
    include(CMakePackageConfigHelpers)

    if (REGENERATE_CLIENTS AND NOT ENABLE_VIRTUAL_OPERATIONS)
        if (PLATFORM_LINUX OR PLATFORM_APPLE)
            Message(STATUS "${BoldYellow}You are regenerating service client's source code and is turning ENABLE_VIRTUAL_OPERATIONS off. If you are targeting smaller binary size, read description string of ENABLE_VIRTUAL_OPERATIONS.${ColourReset}")
        endif ()
    endif ()

    # use response files to prevent command-line-too-big errors for large libraries like iam
    set(CMAKE_CXX_USE_RESPONSE_FILE_FOR_OBJECTS 1)
    set(CMAKE_CXX_USE_RESPONSE_FILE_FOR_INCLUDES 1)
    set(CMAKE_CXX_RESPONSE_FILE_LINK_FLAG "@")

    if (COMMAND apply_pre_project_platform_settings)
        apply_pre_project_platform_settings()
    endif ()

    include(initialize_project_version)

    if (BUILD_SHARED_LIBS OR FORCE_SHARED_CRT)
        set(STATIC_CRT OFF)
    else ()
        set(STATIC_CRT ON)
    endif ()

    # build the sdk targets
    project("aws-cpp-sdk-all" VERSION "${PROJECT_VERSION}" LANGUAGES CXX)

    find_package(Python3 COMPONENTS Interpreter Development)
    set(PYTHON3_CMD ${PYTHON_EXECUTABLE})

    # ENABLE_ZLIB_REQUEST_COMPRESSION should be ON by default if ZLIB is available
    if(ENABLE_ZLIB_REQUEST_COMPRESSION)
        find_package(ZLIB QUIET)
        if ( NOT ZLIB_FOUND)
            set(ENABLE_ZLIB_REQUEST_COMPRESSION
                    OFF CACHE BOOL
                    "For services that support it, request content will be compressed. On by default if dependency available"
                    FORCE)
            message(WARNING "ZLIB is not available, it will not be used to compress requests")
        else()

=== generated/smoke-tests/directory-service-data/CMakeLists.txt ===
add_project(directory-service-data-smoke-tests
"Tests for the AWS DIRECTORY-SERVICE-DATA C++ SDK"
testing-resources
aws-cpp-sdk-directory-service-data
aws-cpp-sdk-core
)
file(GLOB AWS_DIRECTORY-SERVICE-DATA_GENERATED_SMOKE_TEST_SRC
"${CMAKE_CURRENT_SOURCE_DIR}/../RunTests.cpp"
"${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
)
if(MSVC AND BUILD_SHARED_LIBS)
    add_definitions(-DGTEST_LINKED_AS_SHARED_LIBRARY=1)
endif()

if (CMAKE_CROSSCOMPILING)
    set(AUTORUN_UNIT_TESTS OFF)
endif()

if (AUTORUN_UNIT_TESTS)
    enable_testing()
endif()

if(PLATFORM_ANDROID AND BUILD_SHARED_LIBS)
    add_library(${PROJECT_NAME} "${AWS_DIRECTORY-SERVICE-DATA_GENERATED_SMOKE_TEST_SRC}")
else()
    add_executable(${PROJECT_NAME} "${AWS_DIRECTORY-SERVICE-DATA_GENERATED_SMOKE_TEST_SRC}")
endif()

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

target_include_directories(${PROJECT_NAME} PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/../../src/aws-cpp-sdk-directory-service-data/include)

target_link_libraries(${PROJECT_NAME}
    ${PROJECT_LIBS})

if(NOT CMAKE_CROSSCOMPILING)
    SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
endif()

=== generated/smoke-tests/ds/CMakeLists.txt ===
add_project(ds-smoke-tests
"Tests for the AWS DS C++ SDK"
testing-resources
aws-cpp-sdk-ds
aws-cpp-sdk-core
)
file(GLOB AWS_DS_GENERATED_SMOKE_TEST_SRC
"${CMAKE_CURRENT_SOURCE_DIR}/../RunTests.cpp"
"${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
)
if(MSVC AND BUILD_SHARED_LIBS)
    add_definitions(-DGTEST_LINKED_AS_SHARED_LIBRARY=1)
endif()

if (CMAKE_CROSSCOMPILING)
    set(AUTORUN_UNIT_TESTS OFF)
endif()

if (AUTORUN_UNIT_TESTS)
    enable_testing()
endif()

if(PLATFORM_ANDROID AND BUILD_SHARED_LIBS)
    add_library(${PROJECT_NAME} "${AWS_DS_GENERATED_SMOKE_TEST_SRC}")
else()
    add_executable(${PROJECT_NAME} "${AWS_DS_GENERATED_SMOKE_TEST_SRC}")
endif()

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

target_include_directories(${PROJECT_NAME} PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/../../src/aws-cpp-sdk-ds/include)

target_link_libraries(${PROJECT_NAME}
    ${PROJECT_LIBS})

if(NOT CMAKE_CROSSCOMPILING)
    SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
endif()

=== generated/smoke-tests/elasticsearch-service/CMakeLists.txt ===
add_project(elasticsearch-service-smoke-tests
"Tests for the AWS ELASTICSEARCH-SERVICE C++ SDK"
testing-resources
aws-cpp-sdk-elasticsearch-service
aws-cpp-sdk-core
)
file(GLOB AWS_ELASTICSEARCH-SERVICE_GENERATED_SMOKE_TEST_SRC
"${CMAKE_CURRENT_SOURCE_DIR}/../RunTests.cpp"
"${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
)
if(MSVC AND BUILD_SHARED_LIBS)
    add_definitions(-DGTEST_LINKED_AS_SHARED_LIBRARY=1)
endif()

if (CMAKE_CROSSCOMPILING)
    set(AUTORUN_UNIT_TESTS OFF)
endif()

if (AUTORUN_UNIT_TESTS)
    enable_testing()
endif()

if(PLATFORM_ANDROID AND BUILD_SHARED_LIBS)
    add_library(${PROJECT_NAME} "${AWS_ELASTICSEARCH-SERVICE_GENERATED_SMOKE_TEST_SRC}")
else()
    add_executable(${PROJECT_NAME} "${AWS_ELASTICSEARCH-SERVICE_GENERATED_SMOKE_TEST_SRC}")
endif()

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

target_include_directories(${PROJECT_NAME} PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/../../src/aws-cpp-sdk-elasticsearch-service/include)

target_link_libraries(${PROJECT_NAME}
    ${PROJECT_LIBS})

if(NOT CMAKE_CROSSCOMPILING)
    SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
endif()

=== generated/smoke-tests/elastictranscoder/CMakeLists.txt ===
add_project(elastictranscoder-smoke-tests
"Tests for the AWS ELASTICTRANSCODER C++ SDK"
testing-resources
aws-cpp-sdk-elastictranscoder
aws-cpp-sdk-core
)
file(GLOB AWS_ELASTICTRANSCODER_GENERATED_SMOKE_TEST_SRC
"${CMAKE_CURRENT_SOURCE_DIR}/../RunTests.cpp"
"${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
)
if(MSVC AND BUILD_SHARED_LIBS)
    add_definitions(-DGTEST_LINKED_AS_SHARED_LIBRARY=1)
endif()

if (CMAKE_CROSSCOMPILING)
    set(AUTORUN_UNIT_TESTS OFF)
endif()

if (AUTORUN_UNIT_TESTS)
    enable_testing()
endif()

if(PLATFORM_ANDROID AND BUILD_SHARED_LIBS)
    add_library(${PROJECT_NAME} "${AWS_ELASTICTRANSCODER_GENERATED_SMOKE_TEST_SRC}")
else()
    add_executable(${PROJECT_NAME} "${AWS_ELASTICTRANSCODER_GENERATED_SMOKE_TEST_SRC}")
endif()

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

target_include_directories(${PROJECT_NAME} PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/../../src/aws-cpp-sdk-elastictranscoder/include)

target_link_libraries(${PROJECT_NAME}
    ${PROJECT_LIBS})

if(NOT CMAKE_CROSSCOMPILING)
    SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
endif()

=== generated/smoke-tests/lightsail/CMakeLists.txt ===
add_project(lightsail-smoke-tests
"Tests for the AWS LIGHTSAIL C++ SDK"
testing-resources
aws-cpp-sdk-lightsail
aws-cpp-sdk-core
)
file(GLOB AWS_LIGHTSAIL_GENERATED_SMOKE_TEST_SRC
"${CMAKE_CURRENT_SOURCE_DIR}/../RunTests.cpp"
"${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
)
if(MSVC AND BUILD_SHARED_LIBS)
    add_definitions(-DGTEST_LINKED_AS_SHARED_LIBRARY=1)
endif()

if (CMAKE_CROSSCOMPILING)
    set(AUTORUN_UNIT_TESTS OFF)
endif()

if (AUTORUN_UNIT_TESTS)
    enable_testing()
endif()

if(PLATFORM_ANDROID AND BUILD_SHARED_LIBS)
    add_library(${PROJECT_NAME} "${AWS_LIGHTSAIL_GENERATED_SMOKE_TEST_SRC}")
else()
    add_executable(${PROJECT_NAME} "${AWS_LIGHTSAIL_GENERATED_SMOKE_TEST_SRC}")
endif()

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

target_include_directories(${PROJECT_NAME} PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/../../src/aws-cpp-sdk-lightsail/include)

target_link_libraries(${PROJECT_NAME}
    ${PROJECT_LIBS})

if(NOT CMAKE_CROSSCOMPILING)
    SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
endif()

=== generated/smoke-tests/logs/CMakeLists.txt ===
add_project(logs-smoke-tests
"Tests for the AWS LOGS C++ SDK"
testing-resources
aws-cpp-sdk-logs
aws-cpp-sdk-core
)
file(GLOB AWS_LOGS_GENERATED_SMOKE_TEST_SRC
"${CMAKE_CURRENT_SOURCE_DIR}/../RunTests.cpp"
"${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
)
if(MSVC AND BUILD_SHARED_LIBS)
    add_definitions(-DGTEST_LINKED_AS_SHARED_LIBRARY=1)
endif()

if (CMAKE_CROSSCOMPILING)
    set(AUTORUN_UNIT_TESTS OFF)
endif()

if (AUTORUN_UNIT_TESTS)
    enable_testing()
endif()

if(PLATFORM_ANDROID AND BUILD_SHARED_LIBS)
    add_library(${PROJECT_NAME} "${AWS_LOGS_GENERATED_SMOKE_TEST_SRC}")
else()
    add_executable(${PROJECT_NAME} "${AWS_LOGS_GENERATED_SMOKE_TEST_SRC}")
endif()

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

target_include_directories(${PROJECT_NAME} PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/../../src/aws-cpp-sdk-logs/include)

target_link_libraries(${PROJECT_NAME}
    ${PROJECT_LIBS})

if(NOT CMAKE_CROSSCOMPILING)
    SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
endif()

=== generated/src/aws-cpp-sdk-accessanalyzer/CMakeLists.txt ===
add_project(aws-cpp-sdk-accessanalyzer "C++ SDK for the AWS accessanalyzer service" aws-cpp-sdk-core)

file(GLOB AWS_ACCESSANALYZER_HEADERS
    "include/aws/accessanalyzer/*.h"
)

file(GLOB AWS_ACCESSANALYZER_MODEL_HEADERS
    "include/aws/accessanalyzer/model/*.h"
)

file(GLOB AWS_ACCESSANALYZER_SOURCE
    "source/*.cpp"
)

file(GLOB AWS_ACCESSANALYZER_MODEL_SOURCE
    "source/model/*.cpp"
)

file(GLOB ACCESSANALYZER_UNIFIED_HEADERS
    ${AWS_ACCESSANALYZER_HEADERS}
    ${AWS_ACCESSANALYZER_MODEL_HEADERS}
)

file(GLOB ACCESSANALYZER_UNITY_SRC
    ${AWS_ACCESSANALYZER_SOURCE}
    ${AWS_ACCESSANALYZER_MODEL_SOURCE}
)

if(ENABLE_UNITY_BUILD)
    enable_unity_build("ACCESSANALYZER" ACCESSANALYZER_UNITY_SRC)
endif()

file(GLOB ACCESSANALYZER_SRC
    ${ACCESSANALYZER_UNIFIED_HEADERS}
    ${ACCESSANALYZER_UNITY_SRC}
)

if(WIN32)
    #if we are compiling for visual studio, create a sane directory tree.
    if(MSVC)
        source_group("Header Files\\aws\\accessanalyzer" FILES ${AWS_ACCESSANALYZER_HEADERS})
        source_group("Header Files\\aws\\accessanalyzer\\model" FILES ${AWS_ACCESSANALYZER_MODEL_HEADERS})
        source_group("Source Files" FILES ${AWS_ACCESSANALYZER_SOURCE})
        source_group("Source Files\\model" FILES ${AWS_ACCESSANALYZER_MODEL_SOURCE})
    endif(MSVC)
endif()

set(ACCESSANALYZER_INCLUDES
    "${CMAKE_CURRENT_SOURCE_DIR}/include/"
)

add_library(${PROJECT_NAME} ${ACCESSANALYZER_SRC})
add_library(AWS::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

if(USE_WINDOWS_DLL_SEMANTICS AND BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} PRIVATE "AWS_ACCESSANALYZER_EXPORTS")
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(${PROJECT_NAME} PRIVATE ${PLATFORM_DEP_LIBS} ${PROJECT_LIBS})


setup_install()

install (FILES ${AWS_ACCESSANALYZER_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/accessanalyzer)
install (FILES ${AWS_ACCESSANALYZER_MODEL_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/accessanalyzer/model)

do_packaging()

=== generated/src/aws-cpp-sdk-autoscaling/CMakeLists.txt ===
add_project(aws-cpp-sdk-autoscaling "C++ SDK for the AWS autoscaling service" aws-cpp-sdk-core)

file(GLOB AWS_AUTOSCALING_HEADERS
    "include/aws/autoscaling/*.h"
)

file(GLOB AWS_AUTOSCALING_MODEL_HEADERS
    "include/aws/autoscaling/model/*.h"
)

file(GLOB AWS_AUTOSCALING_SOURCE
    "source/*.cpp"
)

file(GLOB AWS_AUTOSCALING_MODEL_SOURCE
    "source/model/*.cpp"
)

file(GLOB AUTOSCALING_UNIFIED_HEADERS
    ${AWS_AUTOSCALING_HEADERS}
    ${AWS_AUTOSCALING_MODEL_HEADERS}
)

file(GLOB AUTOSCALING_UNITY_SRC
    ${AWS_AUTOSCALING_SOURCE}
    ${AWS_AUTOSCALING_MODEL_SOURCE}
)

if(ENABLE_UNITY_BUILD)
    enable_unity_build("AUTOSCALING" AUTOSCALING_UNITY_SRC)
endif()

file(GLOB AUTOSCALING_SRC
    ${AUTOSCALING_UNIFIED_HEADERS}
    ${AUTOSCALING_UNITY_SRC}
)

if(WIN32)
    #if we are compiling for visual studio, create a sane directory tree.
    if(MSVC)
        source_group("Header Files\\aws\\autoscaling" FILES ${AWS_AUTOSCALING_HEADERS})
        source_group("Header Files\\aws\\autoscaling\\model" FILES ${AWS_AUTOSCALING_MODEL_HEADERS})
        source_group("Source Files" FILES ${AWS_AUTOSCALING_SOURCE})
        source_group("Source Files\\model" FILES ${AWS_AUTOSCALING_MODEL_SOURCE})
    endif(MSVC)
endif()

set(AUTOSCALING_INCLUDES
    "${CMAKE_CURRENT_SOURCE_DIR}/include/"
)

add_library(${PROJECT_NAME} ${AUTOSCALING_SRC})
add_library(AWS::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

if(USE_WINDOWS_DLL_SEMANTICS AND BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} PRIVATE "AWS_AUTOSCALING_EXPORTS")
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(${PROJECT_NAME} PRIVATE ${PLATFORM_DEP_LIBS} ${PROJECT_LIBS})


setup_install()

install (FILES ${AWS_AUTOSCALING_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/autoscaling)
install (FILES ${AWS_AUTOSCALING_MODEL_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/autoscaling/model)

do_packaging()

=== generated/src/aws-cpp-sdk-bcm-pricing-calculator/CMakeLists.txt ===
add_project(aws-cpp-sdk-bcm-pricing-calculator "C++ SDK for the AWS bcm-pricing-calculator service" aws-cpp-sdk-core)

file(GLOB AWS_BCM-PRICING-CALCULATOR_HEADERS
    "include/aws/bcm-pricing-calculator/*.h"
)

file(GLOB AWS_BCM-PRICING-CALCULATOR_MODEL_HEADERS
    "include/aws/bcm-pricing-calculator/model/*.h"
)

file(GLOB AWS_BCM-PRICING-CALCULATOR_SOURCE
    "source/*.cpp"
)

file(GLOB AWS_BCM-PRICING-CALCULATOR_MODEL_SOURCE
    "source/model/*.cpp"
)

file(GLOB BCM-PRICING-CALCULATOR_UNIFIED_HEADERS
    ${AWS_BCM-PRICING-CALCULATOR_HEADERS}
    ${AWS_BCM-PRICING-CALCULATOR_MODEL_HEADERS}
)

file(GLOB BCM-PRICING-CALCULATOR_UNITY_SRC
    ${AWS_BCM-PRICING-CALCULATOR_SOURCE}
    ${AWS_BCM-PRICING-CALCULATOR_MODEL_SOURCE}
)

if(ENABLE_UNITY_BUILD)
    enable_unity_build("BCM-PRICING-CALCULATOR" BCM-PRICING-CALCULATOR_UNITY_SRC)
endif()

file(GLOB BCM-PRICING-CALCULATOR_SRC
    ${BCM-PRICING-CALCULATOR_UNIFIED_HEADERS}
    ${BCM-PRICING-CALCULATOR_UNITY_SRC}
)

if(WIN32)
    #if we are compiling for visual studio, create a sane directory tree.
    if(MSVC)
        source_group("Header Files\\aws\\bcm-pricing-calculator" FILES ${AWS_BCM-PRICING-CALCULATOR_HEADERS})
        source_group("Header Files\\aws\\bcm-pricing-calculator\\model" FILES ${AWS_BCM-PRICING-CALCULATOR_MODEL_HEADERS})
        source_group("Source Files" FILES ${AWS_BCM-PRICING-CALCULATOR_SOURCE})
        source_group("Source Files\\model" FILES ${AWS_BCM-PRICING-CALCULATOR_MODEL_SOURCE})
    endif(MSVC)
endif()

set(BCM-PRICING-CALCULATOR_INCLUDES
    "${CMAKE_CURRENT_SOURCE_DIR}/include/"
)

add_library(${PROJECT_NAME} ${BCM-PRICING-CALCULATOR_SRC})
add_library(AWS::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

if(USE_WINDOWS_DLL_SEMANTICS AND BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} PRIVATE "AWS_BCMPRICINGCALCULATOR_EXPORTS")
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(${PROJECT_NAME} PRIVATE ${PLATFORM_DEP_LIBS} ${PROJECT_LIBS})


setup_install()

install (FILES ${AWS_BCM-PRICING-CALCULATOR_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/bcm-pricing-calculator)
install (FILES ${AWS_BCM-PRICING-CALCULATOR_MODEL_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/bcm-pricing-calculator/model)

do_packaging()

=== generated/src/aws-cpp-sdk-bedrock/CMakeLists.txt ===
add_project(aws-cpp-sdk-bedrock "C++ SDK for the AWS bedrock service" aws-cpp-sdk-core)

file(GLOB AWS_BEDROCK_HEADERS
    "include/aws/bedrock/*.h"
)

file(GLOB AWS_BEDROCK_MODEL_HEADERS
    "include/aws/bedrock/model/*.h"
)

file(GLOB AWS_BEDROCK_SOURCE
    "source/*.cpp"
)

file(GLOB AWS_BEDROCK_MODEL_SOURCE
    "source/model/*.cpp"
)

file(GLOB BEDROCK_UNIFIED_HEADERS
    ${AWS_BEDROCK_HEADERS}
    ${AWS_BEDROCK_MODEL_HEADERS}
)

file(GLOB BEDROCK_UNITY_SRC
    ${AWS_BEDROCK_SOURCE}
    ${AWS_BEDROCK_MODEL_SOURCE}
)

if(ENABLE_UNITY_BUILD)
    enable_unity_build("BEDROCK" BEDROCK_UNITY_SRC)
endif()

file(GLOB BEDROCK_SRC
    ${BEDROCK_UNIFIED_HEADERS}
    ${BEDROCK_UNITY_SRC}
)

if(WIN32)
    #if we are compiling for visual studio, create a sane directory tree.
    if(MSVC)
        source_group("Header Files\\aws\\bedrock" FILES ${AWS_BEDROCK_HEADERS})
        source_group("Header Files\\aws\\bedrock\\model" FILES ${AWS_BEDROCK_MODEL_HEADERS})
        source_group("Source Files" FILES ${AWS_BEDROCK_SOURCE})
        source_group("Source Files\\model" FILES ${AWS_BEDROCK_MODEL_SOURCE})
    endif(MSVC)
endif()

set(BEDROCK_INCLUDES
    "${CMAKE_CURRENT_SOURCE_DIR}/include/"
)

add_library(${PROJECT_NAME} ${BEDROCK_SRC})
add_library(AWS::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

if(USE_WINDOWS_DLL_SEMANTICS AND BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} PRIVATE "AWS_BEDROCK_EXPORTS")
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(${PROJECT_NAME} PRIVATE ${PLATFORM_DEP_LIBS} ${PROJECT_LIBS})


setup_install()

install (FILES ${AWS_BEDROCK_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/bedrock)
install (FILES ${AWS_BEDROCK_MODEL_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/bedrock/model)

do_packaging()

=== generated/src/aws-cpp-sdk-budgets/CMakeLists.txt ===
add_project(aws-cpp-sdk-budgets "C++ SDK for the AWS budgets service" aws-cpp-sdk-core)

file(GLOB AWS_BUDGETS_HEADERS
    "include/aws/budgets/*.h"
)

file(GLOB AWS_BUDGETS_MODEL_HEADERS
    "include/aws/budgets/model/*.h"
)

file(GLOB AWS_BUDGETS_SOURCE
    "source/*.cpp"
)

file(GLOB AWS_BUDGETS_MODEL_SOURCE
    "source/model/*.cpp"
)

file(GLOB BUDGETS_UNIFIED_HEADERS
    ${AWS_BUDGETS_HEADERS}
    ${AWS_BUDGETS_MODEL_HEADERS}
)

file(GLOB BUDGETS_UNITY_SRC
    ${AWS_BUDGETS_SOURCE}
    ${AWS_BUDGETS_MODEL_SOURCE}
)

if(ENABLE_UNITY_BUILD)
    enable_unity_build("BUDGETS" BUDGETS_UNITY_SRC)
endif()

file(GLOB BUDGETS_SRC
    ${BUDGETS_UNIFIED_HEADERS}
    ${BUDGETS_UNITY_SRC}
)

if(WIN32)
    #if we are compiling for visual studio, create a sane directory tree.
    if(MSVC)
        source_group("Header Files\\aws\\budgets" FILES ${AWS_BUDGETS_HEADERS})
        source_group("Header Files\\aws\\budgets\\model" FILES ${AWS_BUDGETS_MODEL_HEADERS})
        source_group("Source Files" FILES ${AWS_BUDGETS_SOURCE})
        source_group("Source Files\\model" FILES ${AWS_BUDGETS_MODEL_SOURCE})
    endif(MSVC)
endif()

set(BUDGETS_INCLUDES
    "${CMAKE_CURRENT_SOURCE_DIR}/include/"
)

add_library(${PROJECT_NAME} ${BUDGETS_SRC})
add_library(AWS::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

set_compiler_flags(${PROJECT_NAME})
set_compiler_warnings(${PROJECT_NAME})

if(USE_WINDOWS_DLL_SEMANTICS AND BUILD_SHARED_LIBS)
    target_compile_definitions(${PROJECT_NAME} PRIVATE "AWS_BUDGETS_EXPORTS")
endif()

target_include_directories(${PROJECT_NAME} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)

target_link_libraries(${PROJECT_NAME} PRIVATE ${PLATFORM_DEP_LIBS} ${PROJECT_LIBS})


setup_install()

install (FILES ${AWS_BUDGETS_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/budgets)
install (FILES ${AWS_BUDGETS_MODEL_HEADERS} DESTINATION ${INCLUDE_DIRECTORY}/aws/budgets/model)

do_packaging()

=== PKGBUILD ===
# Maintainer: Jeroen Ooms <jeroen@berkeley.edu>

_realname=aws-sdk-cpp
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.11.479
pkgrel=1
pkgdesc="AWS SDK for C++ (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/aws/aws-sdk-cpp"
msys2_references=(
  'archlinux: aws-sdk-cpp'
)
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-aws-c-common"
         "${MINGW_PACKAGE_PREFIX}-aws-c-event-stream"
         "${MINGW_PACKAGE_PREFIX}-aws-crt-cpp"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-python")
source=("https://github.com/aws/aws-sdk-cpp/archive/${pkgver}/${_realname}-${pkgver}.tar.gz"
        "aws-sdk-cpp-pr-1333.patch"
        "0001-fix-dll-import-libary-folder.patch")
sha256sums=('2151d464b57cc545f11e6d227c748ae0a581a5d9b206eaf4e231c7f3fa0c555a'
            '9eacf0b0bbe978ef69f14bbd0254c96018d3ca84835f1d08409f57ca9831edde'
            'ffa3b28970cce12ba24856d9245e2581c6cb4da7faf740377e99f6ef84bcffc4')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Nbp1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd "${_realname}-${pkgver}"
  apply_patch_with_msg \
    aws-sdk-cpp-pr-1333.patch \
    0001-fix-dll-import-libary-folder.patch

  # For clang
  sed -e "s/-fPIC//g" -i cmake/compiler_settings.cmake

  find . -name "*.orig" -exec rm -f {} \;
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  mkdir -p "${srcdir}/build-${MSYSTEM}-static" && cd "${srcdir}/build-${MSYSTEM}-static"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake.exe \
      -G "Ninja" \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=OFF \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DCMAKE_PREFIX_PATH="${MINGW_PREFIX}" \
      -DCMAKE_MODULE_PATH="${MINGW_PREFIX}"/lib/cmake \
      -DAWS_SDK_WARNINGS_ARE_ERRORS=OFF \
      -DBUILD_ONLY="access-management;config;identity-management;lambda;s3;sts;transfer" \
      -DENABLE_UNITY_BUILD=ON \
      -DENABLE_TESTING=OFF \
      -DBUILD_DEPS=OFF \
      -DPYTHON_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build ./

  mkdir -p "${srcdir}/build-${MSYSTEM}-shared" && cd "${srcdir}/build-${MSYSTEM}-shared"

  LDFLAGS+=" -Wl,--export-all-symbols" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake.exe \
      -G "Ninja" \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DCMAKE_PREFIX_PATH="${MINGW_PREFIX}" \
      -DCMAKE_MODULE_PATH="${MINGW_PREFIX}"/lib/cmake \
      -DAWS_SDK_WARNINGS_ARE_ERRORS=OFF \
      -DBUILD_ONLY="access-management;config;identity-management;lambda;s3;sts;transfer" \
      -DENABLE_UNITY_BUILD=ON \
      -DENABLE_TESTING=OFF \
      -DBUILD_DEPS=OFF \
      -DPYTHON_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build ./
}

package() {
  cd "${srcdir}/build-${MSYSTEM}-static"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install ./

  cd "${srcdir}/build-${MSYSTEM}-shared"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install ./

  cd "${srcdir}/${_realname}-${pkgver}"
  install -Dm644 LICENSE "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
